﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.Objects.DataClasses;

namespace edm_resepti
{
    public partial class Form1 : Form
    {
        ohjaus5Entities Ctx;
        public Form1()
        {
            InitializeComponent();
            Ctx = new ohjaus5Entities();
        }

        void update_grids()
        {
            Resepti r = (Resepti)bindingSourceResepti.Current;

            bindingSourceLiittyy.DataSource = r.Liittyy;
            dataGridViewLiittyy.DataSource = bindingSourceLiittyy;
            // piilotellaan turhat kentät
            dataGridViewLiittyy.Columns["resepti_reseptiID"].Visible = false;
            dataGridViewLiittyy.Columns["aine_aineID"].Visible = false;
            dataGridViewLiittyy.Columns["Resepti"].Visible = false;


            bindingSourceOhje.DataSource = r.Ohje;
            dataGridViewOhje.DataSource = bindingSourceOhje;
            dataGridViewOhje.Columns["ReseptiID"].Visible = false;
            dataGridViewOhje.Columns["Resepti"].Visible = false;

        }

        
        private void Form1_Load(object sender, EventArgs e)
        {
            bindingSourceResepti.DataSource = from rr in Ctx.Resepti
                                              select rr;
            // sidotaan labeliin
            labelResepti.DataBindings.Add(new Binding("Text", this.bindingSourceResepti, "Nimi", true));
            update_grids();


        }

        private void buttonPrev_Click(object sender, EventArgs e)
        {
            bindingSourceResepti.MovePrevious();
            update_grids();
        }

        private void buttonNext_Click(object sender, EventArgs e)
        {
            bindingSourceResepti.MoveNext();
            update_grids();
        }

        private void buttonLisaa_Click(object sender, EventArgs e)
        {
            // seuraava pitäisi olla transaktiona ja poikkeukset pitää napata kiinni
            Resepti r = new Resepti();
            r.Nimi = "Foobar";
            r.Henkilomaara = 1;
            r.RuokalajiID = 1;
            
            Ctx.Resepti.AddObject(r);
            Ohje ohje = new Ohje();
            ohje.Ohjeteksti = "ohje1";
            ohje.Vaihenro = 1;
            ohje.Resepti = r;
            Ctx.Ohje.AddObject(ohje);
            ohje = new Ohje();
            ohje.Ohjeteksti = "ohje2";
            ohje.Vaihenro = 2;
            ohje.Resepti = r;
            Ctx.Ohje.AddObject(ohje);
            // vasta SaveChanges tallentaa tietokantaan
            Ctx.SaveChanges();
            // ei päivity näkyville ilman seuraavaa
            bindingSourceResepti.DataSource = from rr in Ctx.Resepti
                                              select rr;

        }

        private void buttonPaivita_Click(object sender, EventArgs e)
        {
            // seuraava pitäisi olla transaktiona ja poikkeukset pitää napata kiinni
            Resepti r = (Resepti)bindingSourceResepti.Current;
            r.Nimi = "Bar Foo päivitetty nimi";
            Ohje o = r.Ohje.First(); // ensimmäinen ohje. Pitää muistaa, että ohjeita voi olla monta (one-to-many)
            o.Ohjeteksti = "Päivitetty ohjeteksti";

            Ohje[] kaikki = r.Ohje.ToArray(); // kaikki ohjeet
            foreach (Ohje item in kaikki)
            {
                if ( item.Vaihenro > 1 ) item.Ohjeteksti = "Uusi ohjeteksti";
            }
            Ctx.SaveChanges();


            // ei päivity näkyville ilman seuraavaa
            bindingSourceResepti.DataSource = from rr in Ctx.Resepti
                                              select rr;
        }

        private void buttonPoista_Click(object sender, EventArgs e)
        {
            // poistetaan malliksi resepti
            // huom.tämä poistaa vaikka viite-eheys kieltäisi eli poistaa väkisten liittyvät tiedot 
            // ohje- ja liittyy-tauluista
            Resepti r = (Resepti)bindingSourceResepti.Current;
            Ctx.DeleteObject(r);
            Ctx.SaveChanges();
            update_grids();
        }
    }

    public partial class Resepti : EntityObject
    {
        public override string ToString()
        {
            return this.Nimi;
        }

    }
    public partial class Aine : EntityObject
    {
        public override string ToString()
        {
            return this.Nimi;
        }

    }
    public partial class Liittyy : EntityObject
    {
        public override string ToString()
        {
            return this.Maara.ToString() + " " + this.Yksikko_Lyhenne + " " + this.Aine.Nimi;
        }

    }
    public partial class Yksikko : EntityObject
    {
        public override string ToString()
        {
            return this.Nimi;
        }

    }
}
